> ## Documentation Index
> Fetch the complete documentation index at: https://docs.bubblemaps.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Token Metrics

<Info>**Credit cost:** 25 per request.</Info>

Easy access to token stats and scores.

Magic nodes and time nodes are used to compute adjusted scores. If you need more control over the parameters, use the [Get Token Bubble Map](/data/api/tokens/map) endpoint that includes a similar `metrics` object.

### Response

`supply_stats` describe supply shares percentage in `[0, 1]` format. For exemple, `supply_stats.fresh_wallets = 0.15` means that 15% of the supply is held by fresh wallets.

* `cexs`, `dexs`, `contracts`: exactly what you think it is
* `fresh_wallets`: threshold is less than 10 days old
* `top_10_adjusted`: top 10 entites (after clustering) adjusted to ignore CEXs, DEXs, etc
* `bundles`: top 10 clusters (ignoring CEXs, DEXs, etc)

`scores` are various values pertaining to decentralization. Scales vary

* `bubblemaps_score`: our fine tuned algorithmic score from 0 (less decentralized) to 100 (more decentralized). [Read more](https://bubblemaps.notion.site/Bubblemaps-Decentralization-Score-ba767100c9534945ae390fd2467e4add). Can be `null` on rare occasions when the algorithm is not applicable
* [`gini_index`](https://en.wikipedia.org/wiki/Gini_coefficient) and [`herfindahl_hirschman_index`](https://en.wikipedia.org/wiki/Herfindahl%E2%80%93Hirschman_index): from 0 (equally distributed) to 1 (inequaly distributed). For their calculation we use clustered entities, normalized to exclude CEXs/DEXs holdings
* `nakamoto_coefficient`: minimum number of independent entities needed to reach 50% of the supply

<CardGroup cols={3}>
  <Card title="Magic Nodes" icon="wand-magic-sparkles" href="https://wiki.bubblemaps.io/bubblemaps-v2/magic-nodes" />

  <Card title="Time Nodes" icon="clock" href="https://wiki.bubblemaps.io/bubblemaps-v2/time-nodes" />

  <Card title="Bubblemaps Score" icon="hundred-points" href="https://bubblemaps.notion.site/Bubblemaps-Decentralization-Factor-ba767100c9534945ae390fd2467e4add" />
</CardGroup>


## OpenAPI

````yaml GET /v0/tokens/metrics/{chain}/{token_address}
openapi: 3.1.0
info:
  title: Bubblemaps Data API
  version: 0.2.1
servers:
  - url: https://api.bubblemaps.io
security: []
paths:
  /v0/tokens/metrics/{chain}/{token_address}:
    get:
      tags:
        - v0
      summary: Get Token Metrics
      operationId: get_token_metrics_v0_tokens_metrics__chain___token_address__get
      parameters:
        - name: chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainIdV0'
        - name: token_address
          in: path
          required: true
          schema:
            type: string
            title: Token Address
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MapMetricsV0'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    ChainIdV0:
      type: string
      enum:
        - eth
        - base
        - solana
        - tron
        - bsc
        - apechain
        - sonic
        - ton
        - avalanche
        - polygon
        - monad
        - hyperevm
        - arbitrum
      title: ChainIdV0
    MapMetricsV0:
      properties:
        supply_stats:
          $ref: '#/components/schemas/SupplyStatsV0'
        scores:
          $ref: '#/components/schemas/MapScoresV0'
      type: object
      required:
        - supply_stats
        - scores
      title: MapMetricsV0
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    SupplyStatsV0:
      properties:
        cexs:
          type: number
          title: Cexs
        dexs:
          type: number
          title: Dexs
        contracts:
          type: number
          title: Contracts
        fresh_wallets:
          type: number
          title: Fresh Wallets
        top_10_adjusted:
          type: number
          title: Top 10 Adjusted
        bundles:
          type: number
          title: Bundles
      type: object
      required:
        - cexs
        - dexs
        - contracts
        - fresh_wallets
        - top_10_adjusted
        - bundles
      title: SupplyStatsV0
    MapScoresV0:
      properties:
        bubblemaps_score:
          type: number
          title: Bubblemaps Score
        gini_index:
          type: number
          title: Gini Index
        herfindahl_hirschman_index:
          type: number
          title: Herfindahl Hirschman Index
        nakamoto_coefficient:
          type: integer
          title: Nakamoto Coefficient
      type: object
      required:
        - bubblemaps_score
        - gini_index
        - herfindahl_hirschman_index
        - nakamoto_coefficient
      title: MapScoresV0
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: X-ApiKey

````